Attribute VB_Name = "modMain"
Option Explicit

Const REG_SZ = 1
Const REG_EXPAND_SZ = 2
Const REG_DWORD = 4

Const READ_CONTROL = &H20000
Const KEY_QUERY_VALUE = &H1
Const KEY_SET_VALUE = &H2
Const KEY_CREATE_SUB_KEY = &H4
Const KEY_ENUMERATE_SUB_KEYS = &H8
Const KEY_NOTIFY = &H10
Const KEY_CREATE_LINK = &H20
Const KEY_READ = KEY_QUERY_VALUE + KEY_ENUMERATE_SUB_KEYS + KEY_NOTIFY + READ_CONTROL
Const KEY_WRITE = KEY_SET_VALUE + KEY_CREATE_SUB_KEY + READ_CONTROL
Const KEY_EXECUTE = KEY_READ
Const KEY_ALL_ACCESS = KEY_QUERY_VALUE + KEY_SET_VALUE + _
                       KEY_CREATE_SUB_KEY + KEY_ENUMERATE_SUB_KEYS + _
                       KEY_NOTIFY + KEY_CREATE_LINK + READ_CONTROL
                     
Const HKEY_CLASSES_ROOT = &H80000000
Const HKEY_CURRENT_USER = &H80000001
Const HKEY_LOCAL_MACHINE = &H80000002
Const HKEY_USERS = &H80000003
Const HKEY_PERFORMANCE_DATA = &H80000004

Const ERROR_NONE = 0
Const ERROR_BADKEY = 2
Public Const ERROR_SUCCESS = 0
Public Const ERROR_BADDB = 1
Public Const ERROR_CANTOPEN = 3
Public Const ERROR_CANTREAD = 4
Public Const ERROR_CANTWRITE = 5
Public Const ERROR_OUTOFMEMORY = 6
Public Const ERROR_ARENA_TRASHED = 7
Public Const ERROR_ACCESS_DENIED = 8
Public Const ERROR_INVALID_PARAMETERS = 87
Public Const ERROR_NO_MORE_ITEMS = 259

Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegQueryValueExNULL Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As Long, lpcbData As Long) As Long
Private Declare Function RegQueryValueExString Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Private Declare Function RegQueryValueExLong Lib "advapi32.dll" Alias _
   "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As _
   String, ByVal lpReserved As Long, lpType As Long, lpData As Long, lpcbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long

Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationname As String, ByVal _
    lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, _
    ByVal nSize As Long, ByVal lpFileName As String) As Long

Private Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(7) As Byte
End Type

Private Const S_OK = 0
Private Const SYNCHRONIZE = &H100000
Const PROCESS_QUERY_INFORMATION = &H400
Const STILL_ACTIVE = &H103

Private Declare Function CoCreateGuid Lib "OLE32.DLL" (pGuid As GUID) As Long
Private Declare Function OpenProcess Lib "kernel32" (ByVal dwAccess As Long, ByVal fInherit As Integer, ByVal hObject As Long) As Long
Private Declare Function GetExitCodeProcess Lib "kernel32" (ByVal hProcess As Long, lpExitCode As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long


'these are our general options
Private msTempPath As String        'the SA temp path
Private msSAPath As String          'path to the SA executable
Private msSARulesPath As String     'path to the SA rules
Private mnQuarantine As Integer     'the quarantine options
Private msQuarantinePath As String  'the path to the quarantine directory
Private mbKeepOriginal As Boolean   'whether to use the original message (i.e. when spam isn't detected, not alter it)
Private mlMaxMessageSize As Long    'any message that is over this size is not processed


Sub Main()

    If Not LoadOptions Then End

    Dim sMsgCommandFile As String
    Dim sMsgFile As String
    Dim args() As String
    Dim sTempPath As String
    Dim oFSO As New FileSystemObject
    Dim oStream As TextStream
    Dim sTemp As String
    Dim lResult As Double
    Dim sGUID As String
    Dim bSpam As Boolean
    
    On Error GoTo Errhandler
    
    
    ' Passed Params from the MTA: MessageID ConnectorCode
    args() = Split(Command(), " ")
    
    sMsgCommandFile = GetRegistryString("SOFTWARE\Mail Enable\Mail Enable", "Data Directory") & "\QUEUES\" & args(1) & "\Inbound\" & args(0)
    sMsgFile = GetRegistryString("SOFTWARE\Mail Enable\Mail Enable", "Data Directory") & "\QUEUES\" & args(1) & "\Inbound\Messages\" & args(0)
    
    'quick check to see if the file is over our size limit. No need to process it them
    If oFSO.FileExists(sMsgFile) Then
        If (mlMaxMessageSize > 0) And (oFSO.GetFile(sMsgFile).Size > mlMaxMessageSize) Then
            Set oFSO = Nothing
            End
        End If
    Else
        Set oFSO = Nothing
        End
    End If
    
    'make a unique GUID for our message processing
    sGUID = GetGUID
    
    'create the file to execute, since piping doesn't work with shell function
    sTemp = """" & msSAPath & """ -P -c """ & msSARulesPath & """ < """ & sMsgFile & """ > """ & msTempPath & sGUID & ".MAI"""
    Set oStream = oFSO.OpenTextFile(msTempPath & sGUID & ".BAT", ForAppending, True)
    oStream.WriteLine sTemp
    oStream.Close
    Set oStream = Nothing
    
    'then we process the message through SA outputting to our temp dir
    ShellSynchronous sGUID
    
    bSpam = False
    
    'Check to see if spam was detected - scan for X-Spam-Flag: YES
    If oFSO.FileExists(msTempPath & sGUID & ".MAI") Then
        Set oStream = oFSO.OpenTextFile(msTempPath & sGUID & ".MAI", ForReading, False)
        
        Do While Not oStream.AtEndOfStream
            sTemp = oStream.ReadLine
            If InStr(1, sTemp, "X-Spam-Flag: YES", vbTextCompare) = 1 Then
            
                bSpam = True
                
                oStream.Close
                
                'choose how to handle it
                Select Case mnQuarantine
                Case 0          'pass the SA altered one through to user
                    oFSO.CopyFile msTempPath & sGUID & ".MAI", sMsgFile
                Case 1          'quarantine
                    'this is a spam email, so we quarantine it
                    'quaranting involves moving the message, and the SA result (so we can check why it was rejected)
                    'we actually keep original message so we can pass it through later unaltered
                    'the extension for the SA output will be changed to .SA
                    'the copied message file also has a new filename
                    oFSO.CopyFile sMsgCommandFile, msQuarantinePath & sGUID & ".MAI"
                    oFSO.CopyFile sMsgFile, msQuarantinePath & "Messages\" & sGUID & ".MAI"
                    oFSO.CopyFile msTempPath & sGUID & ".MAI", msQuarantinePath & "Messages\" & sGUID & ".SA"
                    
                    'since we have quarantined it, we want to delete from the queues directory so that it doesn't get picked up
                    oFSO.DeleteFile sMsgCommandFile
                    oFSO.DeleteFile sMsgFile
                Case 2          'delete the email because it is a spam and options tell us to
                    oFSO.DeleteFile sMsgCommandFile
                    oFSO.DeleteFile sMsgFile
                End Select
                Exit Do
            End If
            'if the line is blank, end of headers, so no need to process further
            If Len(sTemp) = 0 Then Exit Do
        Loop
        If Not bSpam Then oStream.Close
    Else
        'SA didn't process it... delete our bat file, log it and exit
        oFSO.DeleteFile msTempPath & sGUID & ".BAT"
        App.LogEvent "SpamAssassin didn't return an email. Configuration problem."
        Set oFSO = Nothing
        End
    End If
                
    'if this isn't spam, we choose to
    If Not bSpam Then
        If mbKeepOriginal Then
            'don't do anything!
        Else
            'if we aren't quarantining, we are replacing the message file with the SA returned one
            oFSO.CopyFile msTempPath & sGUID & ".MAI", sMsgFile, True
        End If
    End If
    
    'delete the files we have created
    oFSO.DeleteFile msTempPath & sGUID & ".MAI"
    oFSO.DeleteFile msTempPath & sGUID & ".BAT"
    
    Set oFSO = Nothing

    Exit Sub

Errhandler:
    App.LogEvent "Could not process pickup event for Connector: " & Err.Description
End Sub


Private Function LoadOptions() As Boolean

    Dim oFSO As New FileSystemObject
    Dim sTemp As String * 255
    Dim lResult As Long
    
    If oFSO.FileExists(App.Path & "\spamassassinconfig.ini") Then
        
        lResult = GetPrivateProfileString("SPAMASSASSIN Plugin Config", "QUARANTINE", "", sTemp, 255, App.Path & "\spamassassinconfig.ini")
        If lResult > 0 Then
            mnQuarantine = Trim$(Left$(sTemp, lResult))
        End If
        
        lResult = GetPrivateProfileString("SPAMASSASSIN Plugin Config", "MAXMESSAGESIZE", "", sTemp, 255, App.Path & "\spamassassinconfig.ini")
        If lResult > 0 Then
            mlMaxMessageSize = Trim$(Left$(sTemp, lResult))
        End If
       
        lResult = GetPrivateProfileString("SPAMASSASSIN Plugin Config", "KEEPORIGINAL", "", sTemp, 255, App.Path & "\spamassassinconfig.ini")
        If lResult > 0 Then
            If Trim$(Left$(sTemp, lResult)) = "1" Then
                mbKeepOriginal = True
            Else
                mbKeepOriginal = False
            End If
        End If
        
        lResult = GetPrivateProfileString("SPAMASSASSIN Plugin Config", "QUARANTINEPATH", "", sTemp, 255, App.Path & "\spamassassinconfig.ini")
        If lResult > 0 Then
            msQuarantinePath = Trim$(Left$(sTemp, lResult))
            
            'make sure it is valid
            If Not oFSO.FolderExists(msQuarantinePath) Then
                App.LogEvent "Quantine path is not a valid directory."
                Err.Raise 20001, "LoadOptions", "Quantine path is not a valid directory."
            End If

            'check to see if there is a Messages subdir, if not create it
            If Not oFSO.FolderExists(oFSO.BuildPath(msQuarantinePath, "Messages")) Then
                oFSO.CreateFolder oFSO.BuildPath(msQuarantinePath, "Messages")
            End If

            If Right$(msQuarantinePath, 1) <> "\" Then
                msQuarantinePath = msQuarantinePath & "\"
            End If

        End If
        
        lResult = GetPrivateProfileString("SPAMASSASSIN Plugin Config", "SPAMASSASSINEXE", "", sTemp, 255, App.Path & "\spamassassinconfig.ini")
        If lResult > 0 Then
            msSAPath = Trim$(Left$(sTemp, lResult))
        End If
        
        lResult = GetPrivateProfileString("SPAMASSASSIN Plugin Config", "SPAMASSASSINRULESPATH", "", sTemp, 255, App.Path & "\spamassassinconfig.ini")
        If lResult > 0 Then
            msSARulesPath = Trim$(Left$(sTemp, lResult))
        End If
        
        lResult = GetPrivateProfileString("SPAMASSASSIN Plugin Config", "TEMPPATH", "", sTemp, 255, App.Path & "\spamassassinconfig.ini")
        If lResult > 0 Then
            msTempPath = Trim$(Left$(sTemp, lResult))

            If Right$(msTempPath, 1) <> "\" Then
                msTempPath = msTempPath & "\"
            End If

        End If
                  
        If Len(msQuarantinePath) = 0 Then
            App.LogEvent "Turning off quarantining for SpamAssassin because no path set in config file"
            mnQuarantine = 0
        End If
        
        Set oFSO = Nothing
        LoadOptions = True
    Else
        App.LogEvent "Can't run SpamAssassin because no plugin config file at path: " & App.Path
        LoadOptions = False
    End If
    
    
End Function


Private Sub ShellSynchronous(ByVal sGUID As String)
        Dim hProcess As Long
        Dim RetVal As Long
        
        hProcess = OpenProcess(PROCESS_QUERY_INFORMATION, False, Shell(Environ("comspec") & " /c """ & msTempPath & sGUID & ".BAT""", vbHide))
        Do
            GetExitCodeProcess hProcess, RetVal
            DoEvents: Sleep 100
        Loop While RetVal = STILL_ACTIVE
        
        'close handle
        CloseHandle hProcess
        
End Sub


Function GetRegistryString(ByVal sKeyName As String, ByVal szValueName As String, Optional sServer As String) As String
    
    On Error Resume Next
    
    Dim cch As Long
    Dim lrc As Long
    Dim lType As Long
    Dim lRetVal As Long
    Dim hKey As Long
    Dim sValue As String
    Dim lValue As Long
    
    lRetVal = RegOpenKeyEx(HKEY_LOCAL_MACHINE, sKeyName, 0, KEY_ALL_ACCESS, hKey)
    lrc = RegQueryValueExNULL(hKey, szValueName, 0&, lType, 0&, cch)
    sValue = String(cch, 0)
    
    Select Case lType
        Case REG_DWORD
            lrc = RegQueryValueExLong(hKey, szValueName, 0&, lType, lValue, cch)
            GetRegistryString = lValue
        Case Else
            lrc = RegQueryValueExString(hKey, szValueName, 0&, lType, sValue, cch)
            GetRegistryString = Left$(sValue, cch - 1)
    End Select
    
    RegCloseKey (hKey)
    
End Function


Public Function GetGUID() As String
    
    Dim lResult As Long
    Dim lguid As GUID
    Dim MyguidString As String
    Dim MyGuidString1 As String
    Dim MyGuidString2 As String
    Dim MyGuidString3 As String
    Dim DataLen As Integer
    Dim StringLen As Integer
    Dim i%
    
    On Error GoTo Errhandler
    
    lResult = CoCreateGuid(lguid)
    If lResult = S_OK Then
        MyGuidString1 = Hex$(lguid.Data1)
        StringLen = Len(MyGuidString1)
        DataLen = Len(lguid.Data1)
        MyGuidString1 = LeadingZeros(2 * DataLen, StringLen) & MyGuidString1
        MyGuidString2 = Hex$(lguid.Data2)
        StringLen = Len(MyGuidString2)
        DataLen = Len(lguid.Data2)
        MyGuidString2 = LeadingZeros(2 * DataLen, StringLen) & Trim$(MyGuidString2)
        MyGuidString3 = Hex$(lguid.Data3)
        StringLen = Len(MyGuidString3)
        DataLen = Len(lguid.Data3)
        MyGuidString3 = LeadingZeros(2 * DataLen, StringLen) & Trim$(MyGuidString3)
        GetGUID = MyGuidString1 & MyGuidString2 & MyGuidString3
        For i% = 0 To 7
            MyguidString = MyguidString & Format$(Hex$(lguid.Data4(i%)), "00")
        Next i%
        GetGUID = GetGUID & MyguidString
    Else
        GetGUID = "00000000"
    End If
    
    Exit Function

Errhandler:
    GetGUID = "00000000"
End Function

Function LeadingZeros(ExpectedLen As Integer, ActualLen As Integer) As String
    LeadingZeros = String$(ExpectedLen - ActualLen, "0")
End Function
